#ifndef ENEMY_H_
#define ENEMY_H_

#include <dc/sound/sfxmgr.h>
#include <vector>
#include "Path.h"
#include "Sprite.h"

class Player;
class Laser;
class Enemy : public Sprite
{
private:
	int currentPointIndex;
	bool isFinishedOnPath;
public:
	Enemy();
	Enemy(std::string initialImagePath, float initialImageWidth, float initialImageHeight, float initalX, float initialY, float initialZ, float initialWidth, float initialHeight);
	void move(float xVelocity, float yVelocity, std::vector<Player> &players, std::vector<Laser> &lasers);
	void moveToPoint(Point p, std::vector<Player> &players, std::vector<Laser> &lasers);
	void moveOnPath(Path &path, std::vector<Player> &players, std::vector<Laser> &lasers);
	bool finishedPath(Path currentPath);
	void shoot(float xVelocity, float yVelocity, std::vector<Laser> &lasers, sfxhnd_t &laserSound);
};

#endif
