#ifndef GLOBALS_H
#define GLOBALS_H

#include <string>

//GLOBAL CONSTANTS

//Enums should be declared AND defined here
enum {NULL_SCREEN, TITLE_SCREEN, OPTIONS_SCREEN, CREDITS_SCREEN, STORY_SCREEN, GAME_SCREEN, WIN_SCREEN, SURVIVAL_SCREEN, GAME_OVER_SCREEN};
enum {PLAYER1_Z = 1, PLAYER2_Z = 2};

//Screen information
extern const float SCREEN_WIDTH;
extern const float SCREEN_HEIGHT;

//Boundaries
extern const float TOP_BOUNDARY_Y;
extern const float TOP_BOUNDARY_X;
extern const float TOP_BOUNDARY_WIDTH;
extern const float TOP_BOUNDARY_HEIGHT;
extern const float BOTTOM_BOUNDARY_Y;
extern const float BOTTOM_BOUNDARY_X;
extern const float BOTTOM_BOUNDARY_WIDTH;
extern const float BOTTOM_BOUNDARY_HEIGHT;
extern const float LEFT_BOUNDARY_Y;
extern const float LEFT_BOUNDARY_X;
extern const float LEFT_BOUNDARY_WIDTH;
extern const float LEFT_BOUNDARY_HEIGHT;
extern const float RIGHT_BOUNDARY_Y;
extern const float RIGHT_BOUNDARY_X;
extern const float RIGHT_BOUNDARY_WIDTH;
extern const float RIGHT_BOUNDARY_HEIGHT;

extern const std::string DIR;

//Music and sound paths
extern const std::string MUSIC_PATH_BUMPING;
extern const std::string SOUND_PATH_LASER;

//Image paths
extern const std::string IMAGE_PATH_PLAYER_SHIP_1;
extern const std::string IMAGE_PATH_PLAYER_SHIP_2;
extern const std::string IMAGE_PATH_PLAYER_SHIP_3;
extern const std::string IMAGE_PATH_PLAYER_SHIP_4;
extern const std::string IMAGE_PATH_LASER;
extern const std::string IMAGE_PATH_UFO;
extern const std::string IMAGE_PATH_PAUSE;
extern const std::string IMAGE_PATH_PLAYER;
extern const std::string IMAGE_PATH_LIVES;
extern const std::string IMAGE_PATH_NUMBER_0;
extern const std::string IMAGE_PATH_NUMBER_1;
extern const std::string IMAGE_PATH_NUMBER_2;
extern const std::string IMAGE_PATH_NUMBER_3;
extern const std::string IMAGE_PATH_NUMBER_4;
extern const std::string IMAGE_PATH_NUMBER_5;
extern const std::string IMAGE_PATH_NUMBER_6;
extern const std::string IMAGE_PATH_NUMBER_7;
extern const std::string IMAGE_PATH_NUMBER_8;
extern const std::string IMAGE_PATH_NUMBER_9;
extern const std::string IMAGE_PATH_NUMBER;
extern const std::string IMAGE_PATH_GET_READY;
extern const std::string IMAGE_PATH_TITLE_SCREEN;
extern const std::string IMAGE_PATH_CURSOR;
extern const std::string IMAGE_PATH_OPTIONS_SCREEN;
extern const std::string IMAGE_PATH_GAME_OVER_SCREEN;
extern const std::string IMAGE_PATH_CREDITS_SCREEN;
extern const std::string IMAGE_PATH_WIN_SCREEN;
extern const std::string IMAGE_PATH_BACKGROUND[9];
extern const std::string IMAGE_PATH_STORY[27];

extern const int STORY_IMAGES_ON_LEVEL[9];
extern const int STORY_IMAGES_BEFORE_LEVEL[9];

//Image dimensions
extern const float IMAGE_WIDTH_PLAYER_SHIP;
extern const float IMAGE_HEIGHT_PLAYER_SHIP;
extern const float IMAGE_WIDTH_LASER;
extern const float IMAGE_HEIGHT_LASER;
extern const float IMAGE_WIDTH_UFO;
extern const float IMAGE_HEIGHT_UFO;
extern const float IMAGE_WIDTH_PAUSE;
extern const float IMAGE_HEIGHT_PAUSE;
extern const float IMAGE_WIDTH_PLAYER;
extern const float IMAGE_HEIGHT_PLAYER;
extern const float IMAGE_WIDTH_LIVES;
extern const float IMAGE_HEIGHT_LIVES;
extern const float IMAGE_WIDTH_NUMBER_0;
extern const float IMAGE_HEIGHT_NUMBER_0;
extern const float IMAGE_WIDTH_NUMBER_1;
extern const float IMAGE_HEIGHT_NUMBER_1;
extern const float IMAGE_WIDTH_NUMBER_2;
extern const float IMAGE_HEIGHT_NUMBER_2;
extern const float IMAGE_WIDTH_NUMBER_3;
extern const float IMAGE_HEIGHT_NUMBER_3;
extern const float IMAGE_WIDTH_NUMBER_4;
extern const float IMAGE_HEIGHT_NUMBER_4;
extern const float IMAGE_WIDTH_NUMBER_5;
extern const float IMAGE_HEIGHT_NUMBER_5;
extern const float IMAGE_WIDTH_NUMBER_6;
extern const float IMAGE_HEIGHT_NUMBER_6;
extern const float IMAGE_WIDTH_NUMBER_7;
extern const float IMAGE_HEIGHT_NUMBER_7;
extern const float IMAGE_WIDTH_NUMBER_8;
extern const float IMAGE_HEIGHT_NUMBER_8;
extern const float IMAGE_WIDTH_NUMBER_9;
extern const float IMAGE_HEIGHT_NUMBER_9;
extern const float IMAGE_WIDTH_GET_READY;
extern const float IMAGE_HEIGHT_GET_READY;
extern const float IMAGE_WIDTH_TITLE_SCREEN;
extern const float IMAGE_HEIGHT_TITLE_SCREEN;
extern const float IMAGE_WIDTH_CURSOR;
extern const float IMAGE_HEIGHT_CURSOR;
extern const float IMAGE_WIDTH_OPTIONS_SCREEN;
extern const float IMAGE_HEIGHT_OPTIONS_SCREEN;
extern const float IMAGE_WIDTH_GAME_OVER_SCREEN;
extern const float IMAGE_HEIGHT_GAME_OVER_SCREEN;
extern const float IMAGE_WIDTH_CREDITS_SCREEN;
extern const float IMAGE_HEIGHT_CREDITS_SCREEN;
extern const float IMAGE_WIDTH_WIN_SCREEN;
extern const float IMAGE_HEIGHT_WIN_SCREEN;
extern const float IMAGE_WIDTH_BACKGROUND[8];
extern const float IMAGE_HEIGHT_BACKGROUND[8];
extern const float IMAGE_WIDTH_STORY;
extern const float IMAGE_HEIGHT_STORY;

//Sprite Identifiers
extern const int NO_SPRITE;
extern const int MAX_PLAYERS;
extern const std::string SPRITE_PLAYER_SHIP[4];
extern const std::string SPRITE_LASER;
extern const std::string SPRITE_ENEMY;

//Sprite Dimensions
extern const float SPRITE_PLAYER_WIDTH;
extern const float SPRITE_PLAYER_HEIGHT;
extern const float SPRITE_LASER_WIDTH;
extern const float SPRITE_LASER_HEIGHT;
extern const float SPRITE_ENEMY_WIDTH;
extern const float SPRITE_ENEMY_HEIGHT;
extern const float SPRITE_PAUSE_WIDTH;
extern const float SPRITE_PAUSE_HEIGHT;
extern const float SPRITE_WIDTH_TITLE_SCREEN;
extern const float SPRITE_HEIGHT_TITLE_SCREEN;
extern const float SPRITE_WIDTH_CURSOR;
extern const float SPRITE_HEIGHT_CURSOR;
extern const float SPRITE_WIDTH_OPTIONS_SCREEN;
extern const float SPRITE_HEIGHT_OPTIONS_SCREEN;
extern const float SPRITE_WIDTH_GAME_OVER_SCREEN;
extern const float SPRITE_HEIGHT_GAME_OVER_SCREEN;
extern const float SPRITE_WIDTH_CREDITS_SCREEN;
extern const float SPRITE_HEIGHT_CREDITS_SCREEN;
extern const float SPRITE_WIDTH_WIN_SCREEN;
extern const float SPRITE_HEIGHT_WIN_SCREEN;
extern const float SPRITE_WIDTH_BACKGROUND[8];
extern const float SPRITE_HEIGHT_BACKGROUND[8];

//Background Coordinates
extern const float BACKGROUND_STARTING_X[8];
extern const float BACKGROUND_STARTING_Y[8];
extern const float BACKGROUND_STARTING_Z[8];

//Story Coordinates
extern const float STORY_STARTING_X;
extern const float STORY_STARTING_Y;
extern const float STORY_STARTING_Z;

//Text Coordinates
extern const float LIVES_NUMBER_Y_OFFSET;
extern const float PLAYER_NUMBER_Y_OFFSET;
extern const float TEXT_PADDING;
extern const float PLAYER_STATUS_DISTANCE;
extern const float GET_READY_STARTING_X;
extern const float GET_READY_STARTING_Y;
extern const float GET_READY_STARTING_Z;
extern const float PAUSE_STARTING_X;
extern const float PAUSE_STARTING_Y;
extern const float PAUSE_STARTING_Z;
extern const float PLAYER1_STARTING_X;
extern const float PLAYER1_STARTING_Y;
extern const float PLAYER1_STARTING_Z;
extern const float LIVES1_STARTING_X;
extern const float LIVES1_STARTING_Y;
extern const float LIVES1_STARTING_Z;
extern const float PLAYER2_STARTING_X;
extern const float PLAYER2_STARTING_Y;
extern const float PLAYER2_STARTING_Z;
extern const float LIVES2_STARTING_X;
extern const float LIVES2_STARTING_Y;
extern const float LIVES2_STARTING_Z;
extern const float PLAYER3_STARTING_X;
extern const float PLAYER3_STARTING_Y;
extern const float PLAYER3_STARTING_Z;
extern const float LIVES3_STARTING_X;
extern const float LIVES3_STARTING_Y;
extern const float LIVES3_STARTING_Z;
extern const float PLAYER4_STARTING_X;
extern const float PLAYER4_STARTING_Y;
extern const float PLAYER4_STARTING_Z;
extern const float LIVES4_STARTING_X;
extern const float LIVES4_STARTING_Y;
extern const float LIVES4_STARTING_Z;

//Sprite Starting Coordinates
extern const float PLAYER_SHIP1_STARTING_X;
extern const float PLAYER_SHIP1_STARTING_Y;
extern const float PLAYER_SHIP1_STARTING_Z;
extern const float PLAYER_SHIP2_STARTING_X;
extern const float PLAYER_SHIP2_STARTING_Y;
extern const float PLAYER_SHIP2_STARTING_Z;
extern const float PLAYER_SHIP3_STARTING_X;
extern const float PLAYER_SHIP3_STARTING_Y;
extern const float PLAYER_SHIP3_STARTING_Z;
extern const float PLAYER_SHIP4_STARTING_X;
extern const float PLAYER_SHIP4_STARTING_Y;
extern const float PLAYER_SHIP4_STARTING_Z;
extern const float PLAYER_SHIP_STARTING_X_GENERIC;
extern const float PLAYER_SHIP_STARTING_Y_GENERIC;
extern const float LASER_STARTING_Z;
extern const float LASER_OFFSET_X_1;
extern const float LASER_OFFSET_X_2;
extern const float LASER_OFFSET_Y;
extern const float ENEMY_STARTING_Z;

//Sprite velocities
extern const float PLAYER_VELOCITY_Y;
extern const float PLAYER_VELOCITY_X;
extern const float LASER_VELOCITY_Y;
extern const float ENEMY_LASER_VELOCITY_Y;
extern const float ENEMY_MAX_VELOCITY;

//Laser constants
extern const bool LEFT_GUN;
extern const bool RIGHT_GUN;
extern const bool PLAYER_LASER;
extern const bool ENEMY_LASER;

//Enemy constants
extern const int ENEMIES_PER_ROW;
extern const float ENEMY_PADDING;
extern const float ENEMY_FLEET_X_VELOCITY;

//Menus
extern const float TITLE_SCREEN_STARTING_X;
extern const float TITLE_SCREEN_STARTING_Y;
extern const float TITLE_SCREEN_STARTING_Z;
extern const float OPTIONS_SCREEN_STARTING_X;
extern const float OPTIONS_SCREEN_STARTING_Y;
extern const float OPTIONS_SCREEN_STARTING_Z;
extern const float GAME_OVER_SCREEN_STARTING_X;
extern const float GAME_OVER_SCREEN_STARTING_Y;
extern const float GAME_OVER_SCREEN_STARTING_Z;
extern const float CREDITS_SCREEN_STARTING_X;
extern const float CREDITS_SCREEN_STARTING_Y;
extern const float CREDITS_SCREEN_STARTING_Z;
extern const float WIN_SCREEN_STARTING_X;
extern const float WIN_SCREEN_STARTING_Y;
extern const float WIN_SCREEN_STARTING_Z;
extern const float CURSOR_STARTING_X;
extern const float CURSOR_STARTING_Y;
extern const float CURSOR_STARTING_Z;
extern const float CURSOR_Y_VELOCITY;
extern const int TITLE_SCREEN_ENTRIES;
extern const int OPTIONS_SCREEN_ENTRIES;
extern const bool UP;
extern const bool DOWN;
enum { START_ENTRY, SURVIVAL_ENTRY, OPTIONS_ENTRY, CREDITS_ENTRY };
enum { ONE_PLAYER_ENTRY, TWO_PLAYER_ENTRY, THREE_PLAYER_ENTRY, FOUR_PLAYER_ENTRY};

//Miscellaneous
extern const int WIN_LEVEL;
extern const int SOUND_LOW_VOLUME;
extern const int SOUND_HIGH_VOLUME;
extern const int NUMBER_OF_BACKGROUNDS;
extern const int GAME_OVER_TICK_THRESHOLD;
extern const int WIN_TICK_THRESHOLD;
extern const int MOVE_TICK_THRESHOLD;
extern const int A_BUTTON_TICK_THRESHOLD;
extern const int LEVEL_START_TICKS;
extern const int INVINCIBILITY_TICK_THRESHOLD;
extern const int FIRE_TICK_THRESHOLD;
extern const int INITIAL_LIVES;
extern const int MAX_LIVES;
extern const bool IS_COLLISION;
extern const float JOYX_DEGREE_MODIFIER;
extern const float JOYY_DEGREE_MODIFIER;

#endif
