#ifndef INIT_H_
#define INIT_H_

#include <kos.h>
#include <dc/sound/sfxmgr.h>
#include <map>
#include <vector>
#include <string>
#include "Globals.h"
#include "Video.h"
#include "Player.h"
#include "Enemy.h"
#include "Laser.h"
#include "Path.h"
#include "Level.h"
#include "InputState.h"
#include "Input.h"
#include "GameState.h"

class GameState;


void initTitleScreen(pvr_ptr_t &titleScreenImage, pvr_ptr_t &cursorImage);
void initOptionsScreen(pvr_ptr_t &optionsScreenImage, pvr_ptr_t &cursorImage);
void initCreditsScreen(pvr_ptr_t &creditsImage);
void initStoryScreen(std::vector<pvr_ptr_t> &storyImages, int currentLevel);
void initSurvival(InputState &inputState,
		pvr_ptr_t &backgroundImage,
		sfxhnd_t &laserSound,
		std::map<const std::string, pvr_ptr_t> &images,
		std::vector<Player> &players,
		std::vector<Laser> &lasers,
		std::vector<Enemy> &enemies,
		std::vector<Level> &levels,
		std::vector<Path> &paths,
		GameState &gameState);
void initGame(InputState &inputState,
		pvr_ptr_t &backgroundImage,
		sfxhnd_t &laserSound,
		std::map<const std::string, pvr_ptr_t> &images,
		std::vector<Player> &players,
		std::vector<Laser> &lasers,
		std::vector<Enemy> &enemies,
		std::vector<Level> &levels,
		std::vector<Path> &paths,
		GameState &gameState);
void initGameImages(InputState &inputState,
		pvr_ptr_t &backgroundImage,
		sfxhnd_t &laserSound,
		std::map<const std::string, pvr_ptr_t> &images,
		std::vector<Player> &players,
		std::vector<Laser> &lasers,
		std::vector<Enemy> &enemies,
		std::vector<Level> &levels,
		std::vector<Path> &paths,
		GameState &gameState);
void initGameOverScreen(pvr_ptr_t &gameOverImage);
void initWinScreen(pvr_ptr_t &winImage);
void exitGameScreen(GameState & gameState,
		InputState &inputState,
		pvr_ptr_t &backgroundImage,
		std::map<const std::string, pvr_ptr_t> &images,
		std::vector<Player> &players,
		std::vector<Laser> &lasers,
		std::vector<Enemy> &enemies,
		std::vector<Level> &levels,
		std::vector<Path> &paths);
void exitTitleScreen(pvr_ptr_t &titleScreenImage, pvr_ptr_t & cursorImage);
void exitOptionsScreen(pvr_ptr_t &optionsScreenImage, pvr_ptr_t & cursorImage);
void exitGameOverScreen(pvr_ptr_t &gameOverImage);
void exitWinScreen(pvr_ptr_t &winImage);
void exitCreditsScreen(pvr_ptr_t &creditsImage);
void exitStoryScreen(std::vector<pvr_ptr_t> &storyImages);

#endif
