#ifndef LEVELS_H_
#define LEVELS_H_

#include <map>
#include <vector>
#include <string>
#include "Player.h"
#include "Enemy.h"
#include "Laser.h"
#include "Path.h"
#include "Globals.h"

class Level;
void createSurvival(std::vector<Level> &levels);
void restartSurvivalLevel(std::vector<Level> &levels);
void createLevels(std::vector<Level> &levels);

class Level
{
private:
	int numberOfTicks;
	int ticksPerEnemy;
	int numberOfEnemyRows;
	std::vector<int> ticksUntilNewEnemyRow;
	float enemyFleetXCoordinate;
	bool addNewRow;
	int currentRow;
	int currentPathIndex;
	float enemyFleetXVelocity;
	int chanceOfLaser; //The lower the number the higher the chance
	bool levelStarted;
public:
	Level::Level(int initialNumberOfTicks, int initialTicksPerEnemy, int initialNumberOfEnemyRows, float initialEnemyFleetXCoordinate, int initialChanceOfLaser, const std::vector<int> &initialTicksUntilNewEnemyRow);
	void run(std::vector<Player> &players, std::vector<Enemy> &enemies, std::vector<Laser> &lasers, std::vector<Path> &paths, sfxhnd_t &laserSound);
	void setEnemyFleetXCoordinate(float newEnemyFleetXCoordinate);
	bool levelComplete(std::vector<Player> &players, std::vector<Enemy> &enemies);
	void cleanUp(std::vector<Player> &players, std::vector<Enemy> &enemies);
	bool getLevelStarted() const;
	int getNumberOfTicks() const;
};

#endif
