#ifndef PLAYER_H_
#define PLAYER_H_

#include <dc/sound/sfxmgr.h>
#include <vector>
#include "Globals.h"
#include "Sprite.h"

class Player;
bool checkForGameOver(std::vector<Player> players);

class Enemy;
class Laser;
class Player : public Sprite
{
private:
	int lives;
	int invincibilityTicks;
public:
	Player();
	Player(std::string initialImagePath, float initialImageWidth, float initialImageHeight, float initalX, float initialY, float initialZ, float initialWidth, float initialHeight, int initialLives);
	void move(float xVelocity, float yVelocity, std::vector<Enemy> &enemies, std::vector<Laser> &lasers);
	void shoot(float xVelocity, float yVelocity, bool left, std::vector<Laser> &lasers, sfxhnd_t &laserSound);
	int getLives() const;
	void setLives(int newLives);
	void setDead(bool newDead);
	void resetCoordinates();
	void incrementInvincibilityTicks();
	bool invincible();
};

#endif
