#include "../HeaderFiles/Globals.h"
#include "../HeaderFiles/CollisionDetection.h"

bool RectangularCollisionDetection(BoundingBox box1, BoundingBox box2)
{
	//Ensure the x1 coordinate of the first block is less than x2. Do the
	// same for y1 and y2
	NormalizeCoordinates(box1);
	NormalizeCoordinates(box2);

	//Top left point of box1 within box2?
	if (box1.x1 <= box2.x2 && box1.x1 >= box2.x1 && box1.y1 <= box2.y2 && box1.y1 >= box2.y1)
		return true;

	//Top right point of box1 within box2?
	if (box1.x2 <= box2.x2 && box1.x2 >= box2.x1 && box1.y1 <= box2.y2 && box1.y1 >= box2.y1)
		return true;

	//Bottom left point of box1 within box2?
	if (box1.x1 <= box2.x2 && box1.x1 >= box2.x1 && box1.y2 <= box2.y2 && box1.y2 >= box2.y1)
		return true;

	//Bottom right point of box1 within box2?
	if (box1.x2 <= box2.x2 && box1.x2 >= box2.x1 && box1.y2 <= box2.y2 && box1.y2 >= box2.y1)
		return true;

	//No collision
	return false;
}

void NormalizeCoordinates(BoundingBox &box)
{
	if (box.x1 > box.x2)
		swap(box.x1, box.x2);
	if (box.y1 > box.y2)
		swap(box.y1, box.y2);
}
