#include "../HeaderFiles/Globals.h"

//Screen information
const float SCREEN_WIDTH = 640.0f;
const float SCREEN_HEIGHT = 480.0f;

//Boundaries
const float TOP_BOUNDARY_X = 0;
const float TOP_BOUNDARY_Y = 20;
const float TOP_BOUNDARY_WIDTH = SCREEN_WIDTH;
const float TOP_BOUNDARY_HEIGHT = 100; //Arbitrary high number
const float BOTTOM_BOUNDARY_X = 0;
const float BOTTOM_BOUNDARY_Y = SCREEN_HEIGHT - 20;
const float BOTTOM_BOUNDARY_WIDTH = SCREEN_WIDTH;
const float BOTTOM_BOUNDARY_HEIGHT = 100; //Arbitrary high number
const float LEFT_BOUNDARY_X = 20;
const float LEFT_BOUNDARY_Y = 0;
const float LEFT_BOUNDARY_WIDTH = 100; //Arbitrary high number
const float LEFT_BOUNDARY_HEIGHT = SCREEN_HEIGHT;
const float RIGHT_BOUNDARY_X = SCREEN_WIDTH - 20;
const float RIGHT_BOUNDARY_Y = 0;
const float RIGHT_BOUNDARY_WIDTH = 100; //Arbitrary high number
const float RIGHT_BOUNDARY_HEIGHT = SCREEN_HEIGHT;

#define DIR_CD

#ifdef DIR_CD
const std::string DIR = "/cd";
#endif
#ifdef DIR_PC
const std::string DIR = "/pc/home/john/Desktop/Link to Programming/Hidden Cosmos";
#endif

//Music and sound paths
const std::string MUSIC_PATH_BUMPING = "/rd/Bumping.ogg";
const std::string SOUND_PATH_LASER = "/rd/Laser2.wav";

//Image paths
const std::string IMAGE_PATH_PLAYER_SHIP_1 = DIR + "/Media/PlayerShip1.png";
const std::string IMAGE_PATH_PLAYER_SHIP_2 = DIR + "/Media/PlayerShip2.png";
const std::string IMAGE_PATH_PLAYER_SHIP_3 = DIR + "/Media/PlayerShip3.png";
const std::string IMAGE_PATH_PLAYER_SHIP_4 = DIR + "/Media/PlayerShip4.png";
const std::string IMAGE_PATH_LASER = DIR + "/Media/Laser.png";
const std::string IMAGE_PATH_UFO = DIR + "/Media/UFO.png";
const std::string IMAGE_PATH_PAUSE = DIR + "/Media/Pause.png";
const std::string IMAGE_PATH_PLAYER = DIR + "/Media/Player.png";
const std::string IMAGE_PATH_LIVES = DIR + "/Media/Lives.png";
const std::string IMAGE_PATH_NUMBER_0 = DIR + "/Media/0.png";
const std::string IMAGE_PATH_NUMBER_1 = DIR + "/Media/1.png";
const std::string IMAGE_PATH_NUMBER_2 = DIR + "/Media/2.png";
const std::string IMAGE_PATH_NUMBER_3 = DIR + "/Media/3.png";
const std::string IMAGE_PATH_NUMBER_4 = DIR + "/Media/4.png";
const std::string IMAGE_PATH_NUMBER_5 = DIR + "/Media/5.png";
const std::string IMAGE_PATH_NUMBER_6 = DIR + "/Media/6.png";
const std::string IMAGE_PATH_NUMBER_7 = DIR + "/Media/7.png";
const std::string IMAGE_PATH_NUMBER_8 = DIR + "/Media/8.png";
const std::string IMAGE_PATH_NUMBER_9 = DIR + "/Media/9.png";
const std::string IMAGE_PATH_NUMBER = DIR + "/Media/";
const std::string IMAGE_PATH_GET_READY = DIR + "/Media/GetReady.png";
const std::string IMAGE_PATH_TITLE_SCREEN = "rd/TitleScreen.png";
const std::string IMAGE_PATH_CURSOR = DIR + "/Media/UFO.png";
const std::string IMAGE_PATH_OPTIONS_SCREEN = DIR + "/Media/OptionsScreen.png";
const std::string IMAGE_PATH_GAME_OVER_SCREEN = DIR + "/Media/GameOverScreen.png";
const std::string IMAGE_PATH_CREDITS_SCREEN = DIR + "/Media/Credits.png";
const std::string IMAGE_PATH_WIN_SCREEN = DIR + "/Media/Win.png";
const std::string IMAGE_PATH_BACKGROUND[] =
	{ 	"/rd/Background1.png",
		"/rd/Background1.png",
		"/rd/Background1.png",
		"/rd/Background2.png",
		"/rd/Background2.png",
		"/rd/Background2.png",
		"/rd/Background3.png",
		"/rd/Background3.png",
		"/rd/Background3.png"};
const std::string IMAGE_PATH_STORY[] =
	{
		DIR + "/Media/Story1a.png",
		DIR + "/Media/Story1b.png",
		DIR + "/Media/Story1c.png",
		DIR + "/Media/Story1d.png",
		DIR + "/Media/Story2a.png",
		DIR + "/Media/Story2b.png",
		DIR + "/Media/Story2c.png",
		DIR + "/Media/Story3a.png",
		DIR + "/Media/Story3b.png",
		DIR + "/Media/Story3c.png",
		DIR + "/Media/Story4a.png",
		DIR + "/Media/Story4b.png",
		DIR + "/Media/Story4c.png",
		DIR + "/Media/Story4d.png",
		DIR + "/Media/Story4e.png",
		DIR + "/Media/Story5a.png",
		DIR + "/Media/Story5b.png",
		DIR + "/Media/Story6a.png",
		DIR + "/Media/Story7a.png",
		DIR + "/Media/Story7b.png",
		DIR + "/Media/Story8a.png",
		DIR + "/Media/Story8b.png",
		DIR + "/Media/Story8c.png",
		DIR + "/Media/Story8d.png",
		DIR + "/Media/Story8e.png",
		DIR + "/Media/Story9a.png",
		DIR + "/Media/Story9b.png",
	};

const int STORY_IMAGES_ON_LEVEL[] =
	{
		4, 3, 3, 5, 2, 1, 2, 5, 2
	};
const int STORY_IMAGES_BEFORE_LEVEL[] =
	{
		4, 4 + 3, 4 + 3 + 3, 4 + 3 + 3 + 5,
		4 + 3 + 3 + 5 + 2, 4 + 3 + 3 + 5 + 2 + 1,
		4 + 3 + 3 + 5 + 2 + 1 + 2,
		4 + 3 + 3 + 5 + 2 + 1 +2 + 5,
		4 + 3 + 3 + 5 + 2 + 1 +2 + 5 + 2
	};

//Image dimensions
const float IMAGE_WIDTH_PLAYER_SHIP = 32.0f;
const float IMAGE_HEIGHT_PLAYER_SHIP = 32.0f;
const float IMAGE_WIDTH_LASER = 8.0f;
const float IMAGE_HEIGHT_LASER = 8.0f;
const float IMAGE_WIDTH_UFO = 32.0f;
const float IMAGE_HEIGHT_UFO = 32.0f;
const float IMAGE_WIDTH_PAUSE = 128.0f;
const float IMAGE_HEIGHT_PAUSE = 64.0f;
const float IMAGE_WIDTH_PLAYER = 64.0f;
const float IMAGE_HEIGHT_PLAYER = 32.0f;
const float IMAGE_WIDTH_LIVES = 64.0f;
const float IMAGE_HEIGHT_LIVES = 32.0f;
const float IMAGE_WIDTH_NUMBER_0 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_0 = 16.0f;
const float IMAGE_WIDTH_NUMBER_1 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_1 = 16.0f;
const float IMAGE_WIDTH_NUMBER_2 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_2 = 16.0f;
const float IMAGE_WIDTH_NUMBER_3 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_3 = 16.0f;
const float IMAGE_WIDTH_NUMBER_4 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_4 = 16.0f;
const float IMAGE_WIDTH_NUMBER_5 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_5 = 16.0f;
const float IMAGE_WIDTH_NUMBER_6 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_6 = 16.0f;
const float IMAGE_WIDTH_NUMBER_7 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_7 = 16.0f;
const float IMAGE_WIDTH_NUMBER_8 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_8 = 16.0f;
const float IMAGE_WIDTH_NUMBER_9 = 16.0f;
const float IMAGE_HEIGHT_NUMBER_9 = 16.0f;
const float IMAGE_WIDTH_GET_READY = 64.0f;
const float IMAGE_HEIGHT_GET_READY = 32.0f;
const float IMAGE_WIDTH_TITLE_SCREEN = 1024.0f;
const float IMAGE_HEIGHT_TITLE_SCREEN = 512.0f;
const float IMAGE_WIDTH_CURSOR = 32.0f;
const float IMAGE_HEIGHT_CURSOR = 32.0f;
const float IMAGE_WIDTH_OPTIONS_SCREEN = 1024.0f;
const float IMAGE_HEIGHT_OPTIONS_SCREEN = 512.0f;
const float IMAGE_WIDTH_GAME_OVER_SCREEN = 1024.0f;
const float IMAGE_HEIGHT_GAME_OVER_SCREEN = 512.0f;
const float IMAGE_WIDTH_CREDITS_SCREEN = 1024.0f;
const float IMAGE_HEIGHT_CREDITS_SCREEN = 512.0f;
const float IMAGE_WIDTH_WIN_SCREEN = 1024.0f;
const float IMAGE_HEIGHT_WIN_SCREEN = 512.0f;
const float IMAGE_WIDTH_BACKGROUND[] =
		{1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
const float IMAGE_HEIGHT_BACKGROUND[] =
		{512, 512, 512, 512, 512, 512, 512, 512};
const float IMAGE_WIDTH_STORY = 512;
const float IMAGE_HEIGHT_STORY = 128;

//Sprite Identifiers
const int NO_SPRITE = -9999;
const int MAX_PLAYERS = 4;
const std::string SPRITE_PLAYER_SHIP[] = {"Ship1", "Ship2", "Ship3", "Ship4"};
const std::string SPRITE_LASER = "Laser";
const std::string SPRITE_ENEMY = "ENEMY";

//Sprite Dimensions
const float SPRITE_PLAYER_WIDTH = 32.0f;
const float SPRITE_PLAYER_HEIGHT = 32.0f;
const float SPRITE_LASER_WIDTH = 3.0f;
const float SPRITE_LASER_HEIGHT = 8.0f;
const float SPRITE_ENEMY_WIDTH = 32.0f;
const float SPRITE_ENEMY_HEIGHT = 32.0f;
const float SPRITE_PAUSE_WIDTH = 128.0f;
const float SPRITE_PAUSE_HEIGHT = 64.0f;
const float SPRITE_WIDTH_TITLE_SCREEN = 640.0f;
const float SPRITE_HEIGHT_TITLE_SCREEN = 480.0f;
const float SPRITE_WIDTH_CURSOR = 32.0f;
const float SPRITE_HEIGHT_CURSOR = 32.0f;
const float SPRITE_WIDTH_OPTIONS_SCREEN = 640.0f;
const float SPRITE_HEIGHT_OPTIONS_SCREEN = 480.0f;
const float SPRITE_WIDTH_GAME_OVER_SCREEN = 640.0f;
const float SPRITE_HEIGHT_GAME_OVER_SCREEN = 480.0f;
const float SPRITE_WIDTH_CREDITS_SCREEN = 640.0f;
const float SPRITE_HEIGHT_CREDITS_SCREEN = 480.0f;
const float SPRITE_WIDTH_WIN_SCREEN = 640.0f;
const float SPRITE_HEIGHT_WIN_SCREEN = 480.0f;
const float SPRITE_WIDTH_BACKGROUND[] =
		{640, 640, 640, 640, 640, 640, 640, 640};
const float SPRITE_HEIGHT_BACKGROUND[] =
		{480, 480, 480, 480, 480, 480, 480, 480};

//Background Coordinates
const float BACKGROUND_STARTING_X[] =
	{0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f};
const float BACKGROUND_STARTING_Y[] =
	{0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f};
const float BACKGROUND_STARTING_Z[] =
	{1.0f, 2.0f, 3.0f, 4.0f, 5.0f, 6.0f, 7.0f, 8.0f};

//Story Coordinates
const float STORY_STARTING_X = SCREEN_WIDTH / 2 - IMAGE_WIDTH_STORY / 2;
const float STORY_STARTING_Y = BOTTOM_BOUNDARY_Y - IMAGE_HEIGHT_STORY;
const float STORY_STARTING_Z = 2058.0f;

//Text Coordinates
const float LIVES_NUMBER_Y_OFFSET = 2.0f;
const float PLAYER_NUMBER_Y_OFFSET = 7.0f;
const float TEXT_PADDING = 5.0f;
const float PLAYER_STATUS_DISTANCE = 165.0f;
const float GET_READY_STARTING_X = SCREEN_WIDTH / 2 - IMAGE_WIDTH_GET_READY / 2;
const float GET_READY_STARTING_Y = SCREEN_HEIGHT / 2 - IMAGE_HEIGHT_GET_READY / 2;
const float GET_READY_STARTING_Z = 2052.0f;
const float PAUSE_STARTING_X = SCREEN_WIDTH / 2 - SPRITE_PAUSE_WIDTH / 2;
const float PAUSE_STARTING_Y = SCREEN_HEIGHT / 2 - SPRITE_PAUSE_HEIGHT / 2;
const float PAUSE_STARTING_Z = 2053.0f;
const float PLAYER1_STARTING_X = LEFT_BOUNDARY_X;
const float PLAYER1_STARTING_Y = SCREEN_HEIGHT - IMAGE_HEIGHT_PLAYER * 3;
const float PLAYER1_STARTING_Z = 2030.0f;
const float LIVES1_STARTING_X = PLAYER1_STARTING_X;
const float LIVES1_STARTING_Y = PLAYER1_STARTING_Y + IMAGE_HEIGHT_PLAYER - 10.0f;
const float LIVES1_STARTING_Z = 2031.0f;
const float PLAYER2_STARTING_X = PLAYER1_STARTING_X + PLAYER_STATUS_DISTANCE;
const float PLAYER2_STARTING_Y = PLAYER1_STARTING_Y;
const float PLAYER2_STARTING_Z = 2032.0f;
const float LIVES2_STARTING_X = PLAYER2_STARTING_X;
const float LIVES2_STARTING_Y = LIVES1_STARTING_Y;
const float LIVES2_STARTING_Z = 2033.0f;
const float PLAYER3_STARTING_X = PLAYER2_STARTING_X + PLAYER_STATUS_DISTANCE;
const float PLAYER3_STARTING_Y = PLAYER2_STARTING_Y;
const float PLAYER3_STARTING_Z = 2034.0f;
const float LIVES3_STARTING_X = PLAYER3_STARTING_X;
const float LIVES3_STARTING_Y = LIVES2_STARTING_Y;
const float LIVES3_STARTING_Z = 2035.0f;
const float PLAYER4_STARTING_X = PLAYER3_STARTING_X + PLAYER_STATUS_DISTANCE;
const float PLAYER4_STARTING_Y = PLAYER3_STARTING_Y;
const float PLAYER4_STARTING_Z = 2036.0f;
const float LIVES4_STARTING_X = PLAYER4_STARTING_X;
const float LIVES4_STARTING_Y = LIVES3_STARTING_Y;
const float LIVES4_STARTING_Z = 2037.0f;

//Sprite Starting Coordinates
const float PLAYER_SHIP1_STARTING_X = PLAYER1_STARTING_X + IMAGE_WIDTH_PLAYER / 2 - 5.0f;
const float PLAYER_SHIP1_STARTING_Y = PLAYER1_STARTING_Y - IMAGE_HEIGHT_PLAYER - 1;
const float PLAYER_SHIP1_STARTING_Z = 2048.0f;
const float PLAYER_SHIP2_STARTING_X = PLAYER2_STARTING_X + IMAGE_WIDTH_PLAYER / 2 - 5.0f;
const float PLAYER_SHIP2_STARTING_Y = PLAYER2_STARTING_Y - IMAGE_HEIGHT_PLAYER - 1;
const float PLAYER_SHIP2_STARTING_Z = 2049.0f;
const float PLAYER_SHIP3_STARTING_X = PLAYER3_STARTING_X + IMAGE_WIDTH_PLAYER / 2 - 5.0f;
const float PLAYER_SHIP3_STARTING_Y = PLAYER3_STARTING_Y - IMAGE_HEIGHT_PLAYER - 1;
const float PLAYER_SHIP3_STARTING_Z = 2050.0f;
const float PLAYER_SHIP4_STARTING_X = PLAYER4_STARTING_X + IMAGE_WIDTH_PLAYER / 2 - 5.0f;
const float PLAYER_SHIP4_STARTING_Y = PLAYER4_STARTING_Y - IMAGE_HEIGHT_PLAYER - 1;
const float PLAYER_SHIP4_STARTING_Z = 2051.0f;
const float PLAYER_SHIP_STARTING_X_GENERIC = SCREEN_WIDTH / 2 - IMAGE_WIDTH_PLAYER;
const float PLAYER_SHIP_STARTING_Y_GENERIC = BOTTOM_BOUNDARY_Y - IMAGE_HEIGHT_PLAYER - 1;
const float LASER_STARTING_Z = 512.0f;
const float LASER_OFFSET_X_1 = 2.0f;
const float LASER_OFFSET_X_2 = IMAGE_WIDTH_PLAYER_SHIP - LASER_OFFSET_X_1 - SPRITE_LASER_WIDTH;
const float LASER_OFFSET_Y = IMAGE_HEIGHT_LASER + 1;
const float ENEMY_STARTING_Z = 1024.0f;

//Sprite velocities
const float PLAYER_VELOCITY_Y = 8.0f;
const float PLAYER_VELOCITY_X = 8.0f;
const float LASER_VELOCITY_Y = 12.0f;
const float ENEMY_LASER_VELOCITY_Y = 8.0f;
const float ENEMY_MAX_VELOCITY = 5.0f;

//Laser Constants
const bool LEFT_GUN = true;
const bool RIGHT_GUN = false;
const bool PLAYER_LASER = true;
const bool ENEMY_LASER = false;

//Enemy constants
const int ENEMIES_PER_ROW = 14;
const float ENEMY_PADDING = 4.0f;
const float ENEMY_FLEET_X_VELOCITY = 1.0f;

//Menus
const float TITLE_SCREEN_STARTING_X = 0.0f;
const float TITLE_SCREEN_STARTING_Y = 0.0f;
const float TITLE_SCREEN_STARTING_Z = 2060.0f;
const float OPTIONS_SCREEN_STARTING_X = 0.0f;
const float OPTIONS_SCREEN_STARTING_Y = 0.0f;
const float OPTIONS_SCREEN_STARTING_Z = 2061.0f;
const float GAME_OVER_SCREEN_STARTING_X = 0.0f;
const float GAME_OVER_SCREEN_STARTING_Y = 0.0f;
const float GAME_OVER_SCREEN_STARTING_Z = 2062.0f;
const float CREDITS_SCREEN_STARTING_X = 0.0f;
const float CREDITS_SCREEN_STARTING_Y = 0.0f;
const float CREDITS_SCREEN_STARTING_Z = 2063.0f;
const float WIN_SCREEN_STARTING_X = 0.0f;
const float WIN_SCREEN_STARTING_Y = 0.0f;
const float WIN_SCREEN_STARTING_Z = 2064.0f;
const float CURSOR_STARTING_X = 220.0f;
const float CURSOR_STARTING_Y = 245.0f;
const float CURSOR_STARTING_Z = 2065.0f;
const float CURSOR_Y_VELOCITY = 39.0f;
const int TITLE_SCREEN_ENTRIES = 4;
const int OPTIONS_SCREEN_ENTRIES = 4;
const bool UP = true;
const bool DOWN = false;

//Miscellaneous
const int WIN_LEVEL = 8;
const int SOUND_LOW_VOLUME = 180;
const int SOUND_HIGH_VOLUME = 255;
const int NUMBER_OF_BACKGROUNDS = 8;
const int GAME_OVER_TICK_THRESHOLD = 300;
const int WIN_TICK_THRESHOLD = 300;
const int MOVE_TICK_THRESHOLD = 15;
const int A_BUTTON_TICK_THRESHOLD = 30;
const int LEVEL_START_TICKS = 100;
const int INVINCIBILITY_TICK_THRESHOLD = 100;
const int FIRE_TICK_THRESHOLD = 30;
const int INITIAL_LIVES = 3;
const int MAX_LIVES = 9;
const bool IS_COLLISION = true;
const float JOYX_DEGREE_MODIFIER = 10.5833333;
const float JOYY_DEGREE_MODIFIER = JOYX_DEGREE_MODIFIER;
