#include "../HeaderFiles/Laser.h"
#include "../HeaderFiles/Sprite.h"
#include "../HeaderFiles/Player.h"
#include "../HeaderFiles/Enemy.h"

Laser::Laser()
{
}

Laser::Laser(std::string initialImagePath, float initialImageWidth, float initialImageHeight, float initalX, float initialY, float initialZ, float initialWidth, float initialHeight, float initialXVelocity, float initialYVelocity, bool initialPlayerLaser) :
Sprite(initialImagePath, initialImageWidth, initialImageHeight, initalX,  initialY, initialZ, initialWidth, initialHeight),
xVelocity(initialXVelocity),
yVelocity(initialYVelocity),
playerLaser(initialPlayerLaser)
{
}

void Laser::move(float xVelocity, float yVelocity, std::vector<Player> &players, std::vector<Enemy> &enemies)
{
	if (dead)
		return;

	x += xVelocity;
	y += yVelocity;

	if (checkWallCollisions())
		setDead(true);

	if (!playerLaser)
	{
		int playerCollisionsIndex = checkSpriteCollisions(players);
		if (playerCollisionsIndex != NO_SPRITE)
		{
			if (!players[playerCollisionsIndex].invincible())
			{
				players[playerCollisionsIndex].setDead(true);
				setDead(true);
			}
		}
	}

	if (playerLaser)
	{
		int enemyCollisionsIndex = checkSpriteCollisions(enemies);
		if (enemyCollisionsIndex != NO_SPRITE)
		{
			enemies[enemyCollisionsIndex].setDead(true);
			setDead(true);
		}
	}
}

void Laser::move(std::vector<Player> &players, std::vector<Enemy> &enemies)
{
	move(xVelocity, yVelocity, players, enemies);
}

void Laser::setVelocities(float newXVelocity, float newYVelocity)
{
	xVelocity = newXVelocity;
	yVelocity = newYVelocity;
}

void Laser::setPlayerLaser(bool newPlayerLaser)
{
	playerLaser = newPlayerLaser;
}

bool Laser::getPlayerLaser()
{
	return playerLaser;
}

Laser::Laser(const Laser& laser)
{
	imagePath = laser.imagePath;
	x = laser.x;
	y = laser.y;
	z = laser.z;
	width = laser.width;
	height = laser.height;
	dead = laser.dead;
	xVelocity = laser.xVelocity;
	yVelocity = laser.yVelocity;
	playerLaser = laser.playerLaser;
	imageWidth = laser.imageWidth;
	imageHeight = laser.imageHeight;
}
