#include "../HeaderFiles/Menu.h"
#include "../HeaderFiles/Globals.h"

Menu::Menu(int initialMaxIndex)
: index(0),
  maxIndex(initialMaxIndex),
  numberOfTicks(0)
{
}

void Menu::moveCursor(bool direction)
{
	if (direction == UP)
	{
		--index;

		if (index < 0)
			index = maxIndex - 1;
	}
	else
	{
		++index;

		if (index > maxIndex - 1)
			index = 0;
	}
}

int Menu::getCursorIndex() const
{
	return index;
}

void Menu::incrementNumberOfTicks()
{
	if (numberOfTicks < 0)
		resetNumberOfTicks();

	++numberOfTicks;
}

void Menu::resetNumberOfTicks()
{
	numberOfTicks = 0;
}

int Menu::getNumberOfTicks() const
{
	return numberOfTicks;
}
