#include "../HeaderFiles/Video.h"

void loadImage(pvr_ptr_t *image, std::string path, float width, float height)
{
    size_t size = 2;
    size_t size2 = 2;

    for (size = 2; size < width; size *= 2);
    for (size2 = 2; size2 < height; size2 *= 2);

    *image = pvr_mem_malloc(size * size2 * 2); //width * height * 2??
    png_to_texture(path.c_str(), *image, PNG_FULL_ALPHA); //Or PNG_MASK_ALPHA, if using PunchThrough
}

void loadImageArray(pvr_ptr_t **image, std::string path, float width, float height)
{
    size_t size = 2;
    size_t size2 = 2;

    for (size = 2; size < width; size *= 2);
    for (size2 = 2; size2 < height; size2 *= 2);

    **image = pvr_mem_malloc(size * size2 * 2); //width * height * 2??
    png_to_texture(path.c_str(), **image, PNG_FULL_ALPHA); //Or PNG_MASK_ALPHA, if using PunchThrough
}

void freeImage(pvr_ptr_t *image)
{
	if (*image != NULL)
		pvr_mem_free(*image);
}

void freeImageArray(pvr_ptr_t **images)
{
	if (**images != NULL)
		pvr_mem_free(**images);
}

void drawImage(const pvr_ptr_t &image, float x, float y, float layer, float width, float height)
{
    size_t size = 2;
    size_t size2 = 2;

    for (size = 2; size < width; size *= 2);
    for (size2 = 2; size2 < height; size2 *= 2);

    pvr_poly_cxt_t cxt;
    pvr_poly_hdr_t hdr;
    pvr_vertex_t vert;

    //pvr_poly_cxt_txr(&cxt, PVR_LIST_PT_POLY, PVR_TXRFMT_ARGB1555, size, size2, image, PVR_FILTER_NONE);
    pvr_poly_cxt_txr(&cxt, PVR_LIST_TR_POLY, PVR_TXRFMT_ARGB4444, size, size2, image, PVR_FILTER_NONE);
    pvr_poly_compile(&hdr, &cxt);
    pvr_prim(&hdr, sizeof(hdr));

    vert.argb = PVR_PACK_COLOR(1.0f, 1.0f, 1.0f, 1.0f);    
    vert.oargb = 0;
    vert.flags = PVR_CMD_VERTEX;
    
    vert.x = x;
    vert.y = y;
    vert.z = layer;
    vert.u = 0.0;
    vert.v = 0.0;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x + width;
    vert.y = y;
    vert.z = layer;
    vert.u = width / size;
    vert.v = 0.0;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x;
    vert.y = y + height;
    vert.z = layer;
    vert.u = 0.0;
    vert.v = height / size2;
    pvr_prim(&vert, sizeof(vert));
    
    vert.x = x + width;
    vert.y = y + height;
    vert.z = layer;
    vert.u = width / size;
    vert.v = height / size2;
    vert.flags = PVR_CMD_VERTEX_EOL;
    pvr_prim(&vert, sizeof(vert));
}

